<?php

namespace Sprockets\Loadpath;

/**
 * Loadpath manager interface.
 * This is a StrategyInterface in a Strategy design pattern.
 *
 * @author Gabor Sar <gabor.sar@artoon.hu>
 * @package \Sprockets\Loadpath
 */
interface LoadpathManagerInterface
{
    /**
     * Adds a path to the loadPaths (preferd paths) list.
     *
     * @param string $path
     * @throws Exception
     * @return boolean
     */
    public function appendPath($path);

    /**
     * Returns a path's real location, related to loadPaths,
     * if it is contained by any of them.
     * FALSE returned otherwise.
     *
     * @param string $path
     * @param string $basepath Default value: empty string.
     * @throws Exception
     * @return string|boolean
     */
    public function getPath($path, $basepath = '');
}
