<?php

namespace Sprockets\Processor;

/**
 * Example processor class.
 * Prepends an extra comment line to the content.
 *
 * @author Gabor Sar
 * @package Sprockets\Processor
 */
class ExampleProcessor
    extends \Sprockets\Processor\AbstractProcessor
{
    /**
     * Constructor method.
     *
     * @return \Sprockets\Processor\ExampleProcessor
     */
    public function __construct()
    {
        // instantiate receiver
        $this->_receiver = null;

        // return self
        return $this;
    }

    /**
     * Executes this command, replaces all the new-line
     * characters to spaces in the content of the context object.
     */
    public function execute()
    {
        // get content
        $content = $this->_context->getContent();

        // make chages (this is usually done by the receiver object)
        // example: $content = $this->_receiver->getMinifiedJS($content);
        $content = '// I WAS PROCESSED !!!' . PHP_EOL . $content;

        // update content (of the context)
        $this->_context->setContent($content);
    }
}
