<?php

/**
 * URLSpeedTester
 * 
 * @author Gabor Sar <gabor.sar@artoon.hu>
 */
class UrlSpeedTester
{
    public static function getSpeed($url)
    {
        // get curl
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_VERBOSE, false);
        curl_setopt($ch, CURLOPT_TIMEOUT, 180);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 180);

        // get data and time
        $timeStart = microtime(true);
        $data = curl_exec($ch);
        $timeEnd = microtime(true);
        $time = round($timeEnd - $timeStart, 2);

        // check if there are any errors
        $curl_error_no = curl_errno($ch);
        $curl_error = curl_error($ch);

        // close curl
        curl_close($ch);

        // return result
        return $time;
    }

    public static function getSpeeds($urls)
    {
        $result = array();
        foreach ($urls as $index => $url) {
            $speed = self::getSpeed($url);
            $result[$index] = $speed;
        }
        return $result;
    }

}
