<?php

// enable gzip
ob_start('ob_gzhandler');

// set header (javascript + expires after a day (24h))
header('Content-type: application/x-javascript');
header('Expires: ' . gmdate('D, d M Y H:i:s \G\M\T', time() + 86400));

// define paths
define('APPLICATION_PUBLIC_PATH', dirname(__FILE__));
define('APPLICATION_LIBRARY_PATH', dirname(__FILE__) . '/../library');

// get autoloader
function autoloader($class) {
    $class = str_replace('\\', '/', $class);
    require_once APPLICATION_LIBRARY_PATH . '/' . $class . '.php';
}
spl_autoload_register('autoloader');

// instantiate sprockets
$sprockets = new \Sprockets();
$sprockets->setBasepath(APPLICATION_PUBLIC_PATH);

// set extension
// js (JavaScript) is the default extension, so normally
// this line is not necessary
$sprockets->setExtension('js');

// set loadPaths
$sprockets->appendPath('js');
$sprockets->appendPath('js/lib');

// set extra processors
$processor = new \Sprockets\Processor\ExampleProcessor();
$sprockets->addProcessor($processor);

// handle request
echo $sprockets->handleRequest($_SERVER['REQUEST_URI']);
