`//= require <jquery-1.9.1.min>`
`//= require <jquery.tmpl.min>`
`//= require <jquery.flot>`
`//= require <curvedLines>`
`//= require <bootstrap.min>`
`//= require <spine>`
`//= require <manager>`
`//= require <local>`

`//= require <settings>`
`//= require <models/Url>`
`//= require <models/UrlSet>`
`//= require <controllers/MainNav>`
`//= require <controllers/UrlSets>`
`//= require <controllers/NewTest>`
`//= require <controllers/TestInProgress>`

###
Application controller.
@author Gabor Sar <gabor.sar@fusepump.com>
###
class window.App extends Spine.Controller

    elements:
        '#mainNavView'        : 'mainNavEl'        # main navigation view
        '#urlSetsView'        : 'urlSetsEl'        # URL sets page view
        '#newTestView'        : 'newTestEl'        # new test page view
        '#testInProgressView' : 'testInProgressEl' # test in progress view

    constructor: ->
        super
        # instantiate controllers
        # main navigation / controll bar
        @mainNav = new MainNav el: @mainNavEl
        # URL sets page / screen
        @urlSets = new UrlSets el: @urlSetsEl
        # new test page / screen
        @newTest = new NewTest el: @newTestEl
        # test in progress page / screen
        @testInProgress = new TestInProgress el: @testInProgressEl
        # instantiate manager (state machine)
        @manager = new Spine.Manager @urlSets, @newTest, @testInProgress
        # activate NewTest controller (this is the default screen)
        @newTest.active()

# start application
$ -> window.app = new App el: $('body')
