// Generated by CoffeeScript 1.6.2
/*
NewTest controller.
@author Gabor Sar <gabor.sar@artoon.hu>
*/

var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

window.NewTest = (function(_super) {
  __extends(NewTest, _super);

  NewTest.prototype.elements = {
    '#label': 'labelEl',
    '#url': 'urlEl',
    '#saveNewUrlBtn': 'saveNewUrlBtnEl',
    '#numberOfTests': 'numberOfTestsEl',
    '#startTestBtn': 'startTestBtnEl',
    '#urlListTmpl': 'urlListTmplEl',
    '#urlList': 'urlListEl'
  };

  function NewTest() {
    var _this = this;

    NewTest.__super__.constructor.apply(this, arguments);
    this.saveNewUrlBtnEl.click(function() {
      return _this.saveNewUrl();
    });
    this.startTestBtnEl.click(function() {
      return _this.startTest();
    });
    this.el.delegate('#removeAllUrlsBtn', 'click', function() {
      return _this.emptyUrls();
    });
    this.el.delegate('.btn-remove', 'click', this.deleteUrl);
    Url.bind('change refresh', function() {
      return _this.refreshUrlList();
    });
    Spine.bind('navigateto:newtest', function() {
      return _this.active();
    });
    Spine.bind('test:restart', function() {
      return _this.startTest();
    });
    Url.loadLocal();
  }

  NewTest.prototype.startTest = function() {
    var numberOfTests;

    Url.destroyAllTestResults();
    numberOfTests = this.numberOfTestsEl.val();
    return Spine.trigger('test:start', numberOfTests);
  };

  NewTest.prototype.refreshUrlList = function() {
    var isEmpty, params, tmpl;

    Url.saveLocal();
    params = {
      urls: Url.all()
    };
    tmpl = this.urlListTmplEl.tmpl(params);
    this.urlListEl.html(tmpl);
    isEmpty = Url.count() === 0;
    return this.startTestBtnEl.prop('disabled', isEmpty);
  };

  NewTest.prototype.saveNewUrl = function() {
    var url;

    url = new Url({
      label: this.labelEl.val(),
      url: this.urlEl.val()
    });
    return url.save();
  };

  NewTest.prototype.deleteUrl = function() {
    var id;

    id = $(this).val();
    return Url.destroy(id);
  };

  NewTest.prototype.emptyUrls = function() {
    return Url.destroyAll();
  };

  return NewTest;

})(Spine.Controller);
