// Generated by CoffeeScript 1.6.2
//= require ./TestInProgressControl;
/*
TestInProgress controller.
@author Gabor Sar <gabor.sar@artoon.hu>
*/

var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

window.TestInProgress = (function(_super) {
  __extends(TestInProgress, _super);

  TestInProgress.prototype.elements = {
    '#progressBar': 'progressBarEl',
    '#testResultChart > div': 'testResultChartEl',
    '#statisticsTmpl': 'statisticsTmplEl',
    '#statistics': 'statisticsEl',
    '#controlView': 'controlViewEl'
  };

  function TestInProgress() {
    var _this = this;

    TestInProgress.__super__.constructor.apply(this, arguments);
    this.control = new TestInProgressControl({
      el: this.controlViewEl
    });
    this.numberOfTests = 0;
    this.currentTest = 0;
    Url.bind('update:testresult', function() {
      return _this.updateProgressBar();
    });
    Url.bind('update:testresult', function() {
      return _this.updateFlotChart();
    });
    Url.bind('update:testresult', function() {
      return _this.updateStatistics();
    });
    Url.bind('update:testresult', function() {
      return _this.fetchNextTestResults();
    });
    Spine.bind('navigateto:testinprogress', function() {
      return _this.active();
    });
    Spine.bind('test:start', function() {
      return _this.showProgressBar();
    });
    Spine.bind('test:start', function() {
      return _this.emptyFlotChart();
    });
    Spine.bind('test:start', function(numberOfTests) {
      return _this.startTest(numberOfTests);
    });
    Spine.bind('test:finish', function() {
      return _this.hideProgressBar();
    });
    Spine.bind('test:stop', function() {
      return _this.stopTest();
    });
    Spine.bind('test:stop', function() {
      return _this.hideProgressBar();
    });
  }

  TestInProgress.prototype.startTest = function(numberOfTests) {
    Url.destroyAllTestResults();
    this.numberOfTests = numberOfTests;
    this.currentTest = 0;
    return Url.fetchTestResults();
  };

  TestInProgress.prototype.stopTest = function() {
    return Url.request.abort();
  };

  TestInProgress.prototype.fetchNextTestResults = function() {
    if (++this.currentTest < this.numberOfTests) {
      return Url.fetchTestResults();
    } else {
      return Spine.trigger('test:finish');
    }
  };

  TestInProgress.prototype.showProgressBar = function() {
    return this.progressBarEl.slideDown('fast');
  };

  TestInProgress.prototype.updateProgressBar = function() {
    var progress;

    progress = (this.currentTest + 1) / (this.numberOfTests / 100);
    return this.progressBarEl.find('>.bar').css('width', progress + '%');
  };

  TestInProgress.prototype.hideProgressBar = function() {
    var _this = this;

    return this.progressBarEl.slideUp('fast', function() {
      return _this.progressBarEl.find('>.bar').css('width', '0%');
    });
  };

  TestInProgress.prototype.emptyFlotChart = function() {
    return this.flot = $.plot(this.testResultChartEl, [], DEFAULT_FLOT_OPTIONS);
  };

  TestInProgress.prototype.updateFlotChart = function() {
    if (this.currentTest > 0) {
      return this.flot = $.plot(this.testResultChartEl, Url.convertToFlotData(), DEFAULT_FLOT_OPTIONS);
    }
  };

  TestInProgress.prototype.updateStatistics = function() {
    var params, tmpl;

    params = {
      urls: Url.all()
    };
    tmpl = this.statisticsTmplEl.tmpl(params);
    return this.statisticsEl.html(tmpl);
  };

  return TestInProgress;

})(Spine.Controller);
