###
TestInProgressControl controller.
Used inside testInProgress controller as a child controller,
to minimize the size of the parent controller.
@author Gabor Sar <gabor.sar@artoon.hu>
###

class window.TestInProgressControl extends Spine.Controller

    elements:
        '#restartTestBtn' : 'restartTestBtnEl' # restart test button
        '#stopTestBtn'    : 'stopTestBtnEl'    # stop test button

    constructor: ->
        super
        # bind elements' events
        @restartTestBtnEl.click => @restartTest()
        @stopTestBtnEl.click => @stopTest()
        # bind global events
        Spine.bind 'test:start', => @startTest()
        Spine.bind 'test:finish', => @finishTest()

    startTest: ->
        # disable restart button
        @restartTestBtnEl.prop 'disabled', true
        # enable stop button
        @stopTestBtnEl.prop 'disabled', false

    restartTest: ->
        # trigger global event (send message to mediator)
        Spine.trigger 'test:restart'

    finishTest: ->
        # enable restart button
        @restartTestBtnEl.prop 'disabled', false
        # disable stop button
        @stopTestBtnEl.prop 'disabled', true

    stopTest: ->
        # disable restart button
        # enable stop button
        @finishTest()
        # trigger global event (send message to mediator)
        Spine.trigger 'test:stop'        
