// Generated by CoffeeScript 1.6.2
/*
TestInProgressControl controller.
Used inside testInProgress controller as a child controller,
to minimize the size of the parent controller.
@author Gabor Sar <gabor.sar@artoon.hu>
*/

var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

window.TestInProgressControl = (function(_super) {
  __extends(TestInProgressControl, _super);

  TestInProgressControl.prototype.elements = {
    '#restartTestBtn': 'restartTestBtnEl',
    '#stopTestBtn': 'stopTestBtnEl'
  };

  function TestInProgressControl() {
    var _this = this;

    TestInProgressControl.__super__.constructor.apply(this, arguments);
    this.restartTestBtnEl.click(function() {
      return _this.restartTest();
    });
    this.stopTestBtnEl.click(function() {
      return _this.stopTest();
    });
    Spine.bind('test:start', function() {
      return _this.startTest();
    });
    Spine.bind('test:finish', function() {
      return _this.finishTest();
    });
  }

  TestInProgressControl.prototype.startTest = function() {
    this.restartTestBtnEl.prop('disabled', true);
    return this.stopTestBtnEl.prop('disabled', false);
  };

  TestInProgressControl.prototype.restartTest = function() {
    return Spine.trigger('test:restart');
  };

  TestInProgressControl.prototype.finishTest = function() {
    this.restartTestBtnEl.prop('disabled', false);
    return this.stopTestBtnEl.prop('disabled', true);
  };

  TestInProgressControl.prototype.stopTest = function() {
    this.finishTest();
    return Spine.trigger('test:stop');
  };

  return TestInProgressControl;

})(Spine.Controller);
