// Generated by CoffeeScript 1.6.2
/*
UrlSets controller.
@author Gabor Sar <gabor.sar@artoon.hu>
*/

var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

window.UrlSets = (function(_super) {
  __extends(UrlSets, _super);

  UrlSets.prototype.elements = {
    '#nameOfNewSet': 'nameOfNewSetEl',
    '#saveNewSetBtn': 'saveNewSetBtnEl',
    '#urlSetsTmpl': 'urlSetsTmplEl',
    '#urlSets': 'urlSetsEl'
  };

  function UrlSets() {
    var _this = this;

    UrlSets.__super__.constructor.apply(this, arguments);
    this.saveNewSetBtnEl.click(function() {
      return _this.saveNewUrlSet();
    });
    this.el.delegate('#removeAllUrlSetsBtn', 'click', function() {
      return _this.emptyUrlSets();
    });
    this.el.delegate('.btn-load', 'click', this.loadUrlSet);
    this.el.delegate('.btn-remove', 'click', this.deleteUrlSet);
    this.el.delegate('.btn-overwrite', 'click', this.overwriteUrlSet);
    UrlSet.bind('change refresh', function() {
      return _this.refreshUrlSetList();
    });
    Spine.bind('navigateto:urlsets', function() {
      return _this.active();
    });
    Spine.bind('navigateto:urlsets', function() {
      return _this.updateInput();
    });
    UrlSet.loadLocal();
  }

  UrlSets.prototype.updateInput = function() {
    var isEmpty;

    isEmpty = Url.count() === 0;
    this.nameOfNewSetEl.prop('disabled', isEmpty);
    return this.saveNewSetBtnEl.prop('disabled', isEmpty);
  };

  UrlSets.prototype.refreshUrlSetList = function() {
    var params, tmpl;

    UrlSet.saveLocal();
    params = {
      sets: UrlSet.all()
    };
    tmpl = this.urlSetsTmplEl.tmpl(params);
    return this.urlSetsEl.html(tmpl);
  };

  UrlSets.prototype.saveNewUrlSet = function() {
    var urlSet;

    urlSet = new UrlSet({
      name: this.nameOfNewSetEl.val(),
      urls: JSON.stringify(Url)
    });
    return urlSet.save();
  };

  UrlSets.prototype.overwriteUrlSet = function() {
    var id, urlSet;

    id = $(this).val();
    urlSet = UrlSet.find(id);
    urlSet.urls = JSON.stringify(Url);
    return urlSet.save();
  };

  UrlSets.prototype.loadUrlSet = function() {
    var id, urls;

    id = $(this).val();
    urls = UrlSet.find(id).urls;
    Url.refresh(urls, {
      clear: true
    });
    return Spine.trigger('navigateto:newtest');
  };

  UrlSets.prototype.deleteUrlSet = function() {
    var id;

    id = $(this).val();
    return UrlSet.destroy(id);
  };

  UrlSets.prototype.emptyUrlSets = function() {
    return UrlSet.destroyAll();
  };

  return UrlSets;

})(Spine.Controller);
