// Generated by CoffeeScript 1.6.2
/*
Url model.
@author Gabor Sar <gabor.sar@artoon.hu>
*/

var _ref,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

window.Url = (function(_super) {
  __extends(Url, _super);

  function Url() {
    _ref = Url.__super__.constructor.apply(this, arguments);
    return _ref;
  }

  Url.extend(Spine.Model.Local);

  Url.configure('Url', 'label', 'url', 'test_results');

  Url.urlsToJson = function() {
    return {
      urls: this.all().map(function(value) {
        return value.toJSON();
      })
    };
  };

  Url.fetchTestResults = function() {
    var _this = this;

    return this.request = jQuery.ajax({
      url: 'ajax/getUrlsSpeed.php',
      type: 'POST',
      dataType: 'json',
      data: this.urlsToJson(),
      success: function(data) {
        return _this.addTestResults(data);
      }
    });
  };

  Url.addTestResults = function(testResults) {
    var _this = this;

    jQuery.each(testResults, function(index, value) {
      return _this.find(index).addTestResult(value);
    });
    return this.trigger('update:testresult');
  };

  Url.destroyAllTestResults = function() {
    return this.each(function(url) {
      url.test_results = [];
      return url.update();
    });
  };

  Url.convertToFlotData = function() {
    return this.all().map(function(url) {
      url.data = url.test_results.map(function(testResult, index) {
        return [index, testResult];
      });
      return url;
    });
  };

  Url.prototype.addTestResult = function(testResult) {
    if (!this.test_results) {
      this.test_results = [];
    }
    this.test_results.push(testResult);
    return this.update();
  };

  Url.prototype.getMinResult = function() {
    if (this.test_results) {
      return Math.min.apply(Math, this.test_results);
    } else {
      return 0;
    }
  };

  Url.prototype.getMaxResult = function() {
    if (this.test_results) {
      return Math.max.apply(Math, this.test_results);
    } else {
      return 0;
    }
  };

  Url.prototype.getAvgResult = function() {
    var avg, i, sum, testResult, _i, _len, _ref1;

    if (this.test_results) {
      sum = 0;
      _ref1 = this.test_results;
      for (i = _i = 0, _len = _ref1.length; _i < _len; i = ++_i) {
        testResult = _ref1[i];
        sum += testResult;
      }
      return avg = (sum / this.test_results.length).toFixed(2);
    } else {
      return 0;
    }
  };

  return Url;

})(Spine.Model);
