<?php

// location of the cache files
define('BASEPATH', realpath(dirname(__FILE__) . '/../public_html'));

/**
 * Clears cache files (recursively) inside a directory.
 * 
 * @param string $dir Path of the `target` directory.
 */
function clearCache($dir)
{
    $elements = scandir($dir);
    foreach ($elements as $element) {
        if ($element !== '..' && $element !== '.') {

            // get required infomration about this element
            $path = realpath($dir . '/' . $element);
            $isDir = is_dir($path);
            $isFile = is_file($path);
            $extension = pathinfo($path, PATHINFO_EXTENSION);

            if ($isFile && $extension === 'cache') {

                // if this is a .cache file
                unlink($path);
                echo 'DELETED: ' . str_replace(BASEPATH, '.', $path) . PHP_EOL;

            } elseif ($isDir) {

                // if this is a directory, clear its cache
                clearCache($path);
            }
        }
    }
}

// clear cache
clearCache(BASEPATH);
